#ifndef EFL_IO_WRITER_EO_HH
#define EFL_IO_WRITER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_writer.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace io { 
struct Writer;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Writer> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Writer;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Writer {
   ::efl::eolian::return_traits<bool>::type can_write_get() const;
   ::efl::eolian::return_traits<void>::type can_write_set( ::efl::eolian::in_traits<bool>::type can_write) const;
   ::efl::eolian::return_traits<Eina_Error>::type write( ::efl::eolian::inout_traits<Eina_Slice>::type slice,  ::efl::eolian::out_traits<Eina_Slice*>::type remaining) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_WRITER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Writer() const;
   operator ::efl::io::Writer&();
   operator ::efl::io::Writer const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Writer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Writer : ::efl::eo::concrete
{
   explicit Writer( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Writer(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Writer(Writer const& other) = default;
   Writer(Writer&& other) = default;
   Writer& operator=(Writer const& other) = default;
   Writer& operator=(Writer&& other) = default;
   Writer()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Writer( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Writer(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type can_write_get() const;
   ::efl::eolian::return_traits<void>::type can_write_set( ::efl::eolian::in_traits<bool>::type can_write) const;
   ::efl::eolian::return_traits<Eina_Error>::type write( ::efl::eolian::inout_traits<Eina_Slice>::type slice,  ::efl::eolian::out_traits<Eina_Slice*>::type remaining) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_WRITER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct can_write_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_WRITER_EVENT_CAN_WRITE_CHANGED; }
      typedef void parameter_type;
   } const can_write_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Writer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Writer) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Writer>::value, "");
} } 
#endif
